/**
 * Simulation of process scheduling algorithms
 *
 * Ron Mak
 * Department of Computer Engineering
 * San Jose State University
 */
#ifndef FCFS_H_
#define FCFS_H_

#include "SchedulingAlgorithm.h"

using namespace std;

/**
 * First Come First Served (FCFS) algorithm.
 */
class FCFS : public SchedulingAlgorithm
{
public:
    FCFS(int rcount, int pcount, int qlimit)
        : SchedulingAlgorithm(rcount, pcount, qlimit) {}

    virtual ~FCFS() {}

private:
    void prepare_run(int run_index);
    void run_algorithm();
};

#endif /* FCFS_H_ */
