/**
 * Simulation of process scheduling algorithms
 *
 * Ron Mak
 * Department of Computer Engineering
 * San Jose State University
 */
#ifndef RR_H_
#define RR_H_

#include "SchedulingAlgorithm.h"

/**
 * Round Robin (RR) algorithm.
 */
class RR : public SchedulingAlgorithm
{
public:
    RR(int rcount, int pcount, int qlimit)
        : SchedulingAlgorithm(rcount, pcount, qlimit) {}

    virtual ~RR() {}

private:
    void prepare_run(int run_index);
    void run_algorithm();
};

#endif /* RR_H_ */
