/**
 * Simulation of process scheduling algorithms
 *
 * Ron Mak
 * Department of Computer Engineering
 * San Jose State University
 */
#ifndef SJF_H_
#define SJF_H_

#include "SchedulingAlgorithm.h"

/**
 * Shortest Job First (SJF) algorithm.
 */
class SJF : public SchedulingAlgorithm
{
public:
    SJF(int rcount, int pcount, int qlimit)
        : SchedulingAlgorithm(rcount, pcount, qlimit) {}

    virtual ~SJF() {}

private:
    void prepare_run(int run_index);
    void run_algorithm();
};

#endif /* SJF_H_ */
