/**
 * Simulation of process scheduling algorithms
 *
 * Ron Mak
 * Department of Computer Engineering
 * San Jose State University
 */
#ifndef SRT_H_
#define SRT_H_

#include "SchedulingAlgorithm.h"

/**
 * Shortest Remaining Time Next (SRT) algorithm.
 */
class SRT : public SchedulingAlgorithm
{
public:
    SRT(int rcount, int pcount, int qlimit)
        : SchedulingAlgorithm(rcount, pcount, qlimit) {}

    virtual ~SRT() {}

private:
    void prepare_run(int run_index);
    void run_algorithm();
};

#endif /* SRT_H_ */
