/**
 * Simulation of process scheduling algorithms
 *
 * Ron Mak
 * Department of Computer Engineering
 * San Jose State University
 */
#include <iostream>
#include <stdio.h>
#include <stdlib.h>

#include "FCFS.h"
#include "SJF.h"
#include "SRT.h"
#include "RR.h"
#include "HPF_NP.h"
#include "HPF_P.h"

using namespace std;

const int RUN_COUNT     = 5;
const int PROCESS_COUNT = 20;
const int QUANTUM_LIMIT = 99;

int main()
{
    srand(0);

    FCFS fcfs(RUN_COUNT, PROCESS_COUNT, QUANTUM_LIMIT);
    fcfs.run_simulations();

    SJF sjf(RUN_COUNT, PROCESS_COUNT, QUANTUM_LIMIT);
    sjf.run_simulations();

    SRT srt(RUN_COUNT, PROCESS_COUNT, QUANTUM_LIMIT);
    srt.run_simulations();

    RR rr(RUN_COUNT, PROCESS_COUNT, QUANTUM_LIMIT);
    rr.run_simulations();

    HPF_NP hpf_np(RUN_COUNT, PROCESS_COUNT, QUANTUM_LIMIT);
    hpf_np.run_simulations();

    HPF_P hpf_p(RUN_COUNT, PROCESS_COUNT, QUANTUM_LIMIT);
    hpf_p.run_simulations();

    return 0;
}
